package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseMaterial;
import com.ruoyi.web.base.service.IBaseMaterialService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-02
 */
@RestController
@RequestMapping("/base-material")
public class BaseMaterialController {
    @Autowired
    private IBaseMaterialService baseMaterialService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("物料管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseMaterial baseMaterial, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseMaterialService.count(new QueryWrapper<BaseMaterial>().eq("org_id",loginOrgId).eq("goods_num", baseMaterial.getGoodsNum())) >0 ){
            throw new Exception("该编号已存在");
        }

        baseMaterial.setOrgId(loginOrgId);
        baseMaterial.setCreateBy(getUsername());
        return success(baseMaterialService.save(baseMaterial));
    }

    @ApiOperation("物料管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseMaterial baseMaterial, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseMaterialService.count(new QueryWrapper<BaseMaterial>().ne("id",baseMaterial.getId()).eq("org_id",loginOrgId).eq("goods_num", baseMaterial.getGoodsNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseMaterial.setUpdateBy(getUsername());
        return success(baseMaterialService.updateById(baseMaterial));
    }

    @ApiOperation("物料管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseMaterialService.removeById(s);
        }
        return success();
    }

    @ApiOperation("物料管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( @RequestBody Map<String, String> paramsMap,HttpServletRequest request){
           return success(baseMaterialService.list(new QueryWrapper<BaseMaterial>().eq("org_id",tokenService.getLoginOrgId(request))));

    }

    @ApiOperation("物料管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize,HttpServletRequest request
    ) {
        return success(baseMaterialService.page(new Page<BaseMaterial>(pageNum,pageSize),new QueryWrapper<BaseMaterial>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("物料管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseMaterialService.getById(id));
    }


}
